*-------------------------------------------------------------------------
* bitwise.prg -- Functions to implement FORCE bit operations.
*-------------------------------------------------------------------------
#include common.hdr
#include undoc.hdr

#ifndef WORD                     && careful, this is defined in STRING.HDR
#	define WORD	UINT
#endif
*-------------------------------------------------------------------------
VARDEF PRIVATE
   CHAR                 RCSid = "$Header:$"
ENDDEF
*-------------------------------------------------------------------------
* function: hiword()
*
* description: hiword() uses the concept of the Alias to return the first
*    4 byte word of an 8 byte double word.
*-------------------------------------------------------------------------
FUNCTION &WORD hiword
   PARAMETERS VALUE LONG dword

   VARDEF
      LONG           x
      &WORD          xi[2] BASED x
   ENDDEF

   x = dword

   return xi[1]

ENDPRO
*-------------------------------------------------------------------------
* function: loword()
*
* description: loword() is just like hiword(), but it returns the second
*     4 byte word of the 8 byte double word.
*-------------------------------------------------------------------------
FUNCTION &WORD loword
   PARAMETERS VALUE LONG dword

   VARDEF
      LONG           x
      &WORD          xi[2] BASED x
   ENDDEF

   x = dword

   return xi[0]
ENDPRO
*-------------------------------------------------------------------------
* function: hibyte()
*
* description: The hibyte() and lobyte() functions are just like the
*     the hiword() and loword() functions, except that they split UINTS.
*-------------------------------------------------------------------------
FUNCTION BYTE hibyte
   PARAMETERS VALUE &WORD wordguy

   VARDEF
      &WORD          x
      BYTE           xi[2] BASED x
   ENDDEF

   x = wordguy

   return xi[1]

ENDPRO
*-------------------------------------------------------------------------
* function: lobyte()
*
* description: lobyte() is just like hibyte(), but returns the lower byte.
*-------------------------------------------------------------------------
FUNCTION BYTE lobyte
   PARAMETERS VALUE &WORD wordguy

   VARDEF
      &WORD          x
      BYTE           xi[2] BASED x
   ENDDEF

   x = wordguy

   return xi[0]

ENDPRO
*-------------------------------------------------------------------------
* function: hibytew() and lobytew()
*
* description: These functions are just like hibyte() and lowbyte(), but
*     return the values as &WORDs.
*-------------------------------------------------------------------------
FUNCTION &WORD hibytew
   PARAMETERS VALUE &WORD wordguy

   VARDEF
      &WORD          x
      BYTE           xi[2] BASED x
      &WORD          y
      BYTE           yi[2] BASED y
   ENDDEF

   x = wordguy
   y = 0
   yi[0] = xi[1]

   return y

ENDPRO
*-------------------------------------------------------------------------
FUNCTION &WORD lobytew
   PARAMETERS VALUE &WORD wordguy

   return( and( wordguy, 255 ))
ENDPRO
*-- EOF: bitwise.prg -----------------------------------------------------
