*-------------------------------------------------------------------------
* strdup.prg -- Implements a string duplication, but returns a pointer
*    instead of a string.
*-------------------------------------------------------------------------
#include defs.hdr
#include common.hdr
#include string.hdr
#include alloc.hdr
*-------------------------------------------------------------------------
* function: strdup( )
*
* description:  Given a string, this guy allocates enough memory to fit
*     it in, copies the string into it, and returns a pointer to the
*     newly allocated space.
*-------------------------------------------------------------------------
FUNCTION &POINTER strdup
   PARAMETERS CONST CHAR string

   VARDEF
      &POINTER          newString
   ENDDEF

   newString = alloc( len( string ) + 1 )
   IF newString <> &NULL
      charcpy( newString, string )
   ENDIF

   RETURN newString

ENDPRO
*--EOF: strdup.prg -------------------------------------------------------
