;-------------------------------------------------------------------------
; strings.asm -- String Trim, the real way....
;-------------------------------------------------------------------------
; RCSid = "$Header:$";
;-------------------------------------------------------------------------
			public	_strim
			public	_strcmp
			public	isspace

;-------------------------------------------------------------------------
Mr_Segmerg		segment word public 'CODE'
			assume cs:Mr_Segmerg
;-------------------------------------------------------------------------
; function: isspace()
;
; description: Yep, this guy should be equivalent to the C isspace()
; 	function.  Note that he can only be called from assembler.
;-------------------------------------------------------------------------
isspace			proc	far

			cmp	al,8		; Backspace
			jz	yep_space
			cmp	al,9		; Tab
			jz	yep_space
			cmp	al,10		; LineFeed
			jz	yep_space
			cmp	al,12		; FormFeed
			jz	yep_space
			cmp	al,13		; Carriage Return
			jz	yep_space
			cmp	al,32		; Space
			jz	yep_space

			clc
			jmp	isspace_out

	yep_space:	stc

	isspace_out:	ret
isspace			endp
;-------------------------------------------------------------------------
; function: strim()
;
; description: strim() is a function that trims off the leading and
;	trailing edges of a string.  It doesn't return anything, since
;	it does all of it's work within the string itself.
;-------------------------------------------------------------------------
_strim			proc	far
			push	bp
			mov	bp,sp
			push	ds
			push	si
			push	es
			push	di

	;
	; Our first job is load up DS:SI and ES:DI to point to the
	; string.  No problem.
	;
			lds	ax,[bp].6
			mov	si,ax
			mov	di,ax
			push	ds
			pop	es

	;
	; Now that we've accomplished that, we scan down the string
	; until we either find a 0, or a non-white character.
	; The white's are \f \b \t 0x20 \r \n
	;
	Scan_Front:	lodsb
			and	al,al
			jz	found_z_front

			call	far ptr isspace
			jc	Scan_Front
			dec	si
			jmp	Copy_To_Front

	;
	; If we got here, that means we've found a NULL before any
	; non-white characters.  If that's the case, write a 0 to the
	; front of the string, and return.
	;
   found_z_front:	mov	ax,0
			stosw
			jmp	Strim_Out

	;
	; If we got to here, then we've found the first non-white
	; character.  So, we start copying the characters to the
	; beginning of the string, until we get to the NULL char.
	;

	Copy_To_Front:	lodsb
			stosb
			and	al,al
			jz	Found_End
			jmp	Copy_To_Front

	;
	; Now we're at the NULL character, so we reverse the scanning
	; direction, and write zero's into the string until we get to
	; a non-white character.
	;
	Found_End:	dec	di	; Backup only one
			dec	di
			mov	si,di
			std		; Set the direction flag bit
	Back_Trim:	lodsb
			call	far ptr isspace
			jnc	Strim_Out
			xor	al,al
			stosb
			jmp	Back_Trim

   Strim_Write_Out:	mov	al,0
   			stosb

	Strim_Out:	cld
			pop	di
			pop	es
			pop	si
			pop	ds
			pop	bp
			ret
_strim			endp
;-------------------------------------------------------------------------
; function: strcmp()
;
; description: This guy should be just like C's strcmp().  It returns
;	0 if the two strings are equal, < 0 if the first is greater than
;	the second, and > 0 if the second is greater than the first.
;-------------------------------------------------------------------------
_strcmp			proc	far
			push	bp
			mov	bp,sp
			push	ds
			push	si
			push	es
			push	di

			lds	bx,ss:[bp + 6]
			mov	si,bx

			les	bx,ss:[bp + 10]
			mov	di,bx
		;
		; Time to check for NULL pointers!
		;
			mov	ax,ds
			and	ax,ax
			jz	found_first_end
			mov	ax,es
			and	ax,ax
			jz	found_first_end
	;
	; Here's our main loop.  We have DS:SI set to the first string,
	; and ES:DI set to the second string, so we read them both
	; until with either get a NULL or a difference.
	;

	_strcmp_main:	lodsb
			and	al,al
			jz	found_first_end
			mov	bl, byte ptr es:[di]
			inc	di
			and	bl,bl
			jz	found_second_end
			xor	ah,ah
			xor	bh,bh
			sub	ax,bx
			jz	_strcmp_main

			jmp	_strcmp_out

	;
	; Okay, we've found the end of the first string.
	; If we're also at the end of the second string, then
	; return 0, otherwise return -1.
	;
  found_first_end:	mov	bl, byte ptr es:[di]
			and	bl,bl
			jz	strings_r_same

			mov	ax,-1
			jmp	_strcmp_out

	strings_r_same:	xor	ax,ax
			jmp	_strcmp_out

  found_second_end:	mov	ax,1

	_strcmp_out:	pop	di
			pop	es
			pop	si
			pop	ds
			pop	bp
			ret
_strcmp			endp
;-------------------------------------------------------------------------
Mr_Segmerg		ends

			end
